Subject: Re: bug#48064: texlive-* packages fail to build non-deterministically

From: Thiago Jung Bauermann <[email-masked]>
Date: Mon, 05 Jul 2021 14:27:16 -0300

Hi Ludo,

Em segunda-feira, 5 de julho de 2021, às 06:20:20 -03, Ludovic Courtès 
escreveu:
> Thiago Jung Bauermann <[email-masked]> skribis:
> > LuaTeX has a bug where sometimes it corrupts the heap and aborts. This
> > causes the build of texlive packages to fail at random. The problem is
> > being tracked at https://issues.guix.gnu.org/48064.
> > 
> > While a fix isn't found, switch the default TeX format (and
> > consequently
> > also the engine) to pdftex to avoid the issue.
> > 
> > * guix/build-system/texlive.scm (texlive-build): Change default value
> > of
> > the ‘tex-format’ key parameter to “pdftex”.
> 
> Pushed as 04f9f9158da348e8299e9ab90ec389ba81be46b0 with the text above
> inlined as a FIXME comment.

Thank you!

> On IRC there were concerns about Unicode support, which LuaTeX provides
> but pdftex doesn’t (IIUC), but it would seem that the worst that can
> happen is that documentation of the packages themselves would be
> mangled, which is okay.

I chose pdfTeX for the workaround because it’s the direct “predecessor” to 
LuaTeX, so I thought it would behave most similarly to it. But it’s just an 
uneducated guess.

Searching around a bit¹²³, XeTeX also has native Unicode support, so we 
could also switch to it. Either as the default, or for specific packages 
that need it.

NB: I last used TeX more than 15 years ago, and even then just lightly and 
sporadically. Don’t trust my judgement on TeX-related issues. :-)

> Anyway, it’d be ideal to get feedback from the LuaTeX folks!

Agreed!

-- 
Thanks,
Thiago

¹ https://tex.stackexchange.com/questions/13593/the-differences-between-tex-engines
² https://tex.stackexchange.com/questions/36/differences-between-luatex-context-and-xetex
³ https://www.tug.org/texlive/doc/texlive-en/texlive-en.html#x1-120002.4